
local detection = {}

local desc = 'Ӳ'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')
local ips={}

function detection0_getSlaveHost()
	local webip = GeneralFun.getwebip()
	local value = GeneralFun.getInfo(0,'{"Request":2,"IPs":"'..webip..'"}')	if value == false then return end
	local rcd_osver = value[webip]["version"]
	local result = lua_compareVer(rcd_osver,"2.1")
	
	local value = GeneralFun.getInfo(0,'{"Request":24,"IPs":"'..webip..'"}')		if value == false then return end
	local slaveHost = value[webip]["slaveHost"]
	
	ips[1]={}
	ips[1]["ip"]=webip
	
	if result == 3 or result == 4 then --2.0汾
		for i=1,#slaveHost do
			local tmpIP = slaveHost[i]["ip"]		
			local bConnect = lua_getConnectState(tmpIP)
			if bConnect then
				ips[i+1]={}
				ips[i+1]["ip"]=tmpIP
			end
		end
	else -- 2.1汾
		local value = GeneralFun.getInfo(0,'{"Request":3,"IPs":"'..webip..'"}')	if value == false then return end
		local localMode = value[webip]["localMode"]
		if localMode == "1" or localMode == "3" then
			for i=1,#slaveHost do
				local tmpIP = slaveHost[i]["wanIp"]		
				local bConnect = lua_getConnectState(tmpIP)
				if bConnect then
					ips[i+1]={}
					ips[i+1]["ip"]=tmpIP
				end
			end
		else
			for i=1,#slaveHost do
				local tmpIP = slaveHost[i]["ip"]		
				local bConnect = lua_getConnectState(tmpIP)
				if bConnect then
					ips[i+1]={}
					ips[i+1]["ip"]=tmpIP
				end
			end
		end
	end
end

function detection.Detect()
	local webip = GeneralFun.getwebip()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFile("== "..desc.." ==")
		
	detection0_getSlaveHost()
	
	for i=1,#ips do
		local ip = ips[i]["ip"]
		local value = GeneralFun.getInfo(0,'{"Request":34,"IPs":"'..ip..'"}')		if value == false then return end

		local eccError = string.lower(value[ip]["eccError"])
		if eccError == "yes" then
			local amount = value[ip]["amount"]
			local firstTime = value[ip]["firstTime"]
			local lastTime = value[ip]["lastTime"]
			lua_addTypeTip(p,2,"IP"..ip.." "..firstTime..""..lastTime..""..amount.."ECCڴ澯ϵԶ̼֧")
			lua_addResult(p,2)
		else
			lua_addResult(p,1)
		end
		
		local value = GeneralFun.getInfo(0,'{"Request":40,"IPs":"'..ip..'"}')		if value == false then return end
		local diskDStatus = string.lower(value[ip]["diskDStatus"])
		if diskDStatus ~= 'yes' then
			--	D𻵣޸
			local value = GeneralFun.getInfo(0,'{"Request":41,"IPs":"'..ip..'"}')		if value == false then return end
			local diskDRepair = string.lower(value[ip]["diskDRepair"])		
			lua_SetRepairCode(ip,"41")			
			local tip = "޸"..ip.." 쳣Ժ󡭡"
			lua_addResult(p,3)
			lua_addScore(p,-100)
			lua_addTypeTip(p,3,tip)
		
			lua_afterDetect(p)
			GeneralFun.StopDetect(2,tip)
			lua_alert(tip)
			return
		end
	end
	lua_afterDetect(p)
end
 
return detection