
local detection = {}
 
local desc = '洢'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = GeneralFun.getwebip()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFile("== "..desc.." ==")
		
	local _slaveHost = GeneralFun.oa_get_SlaveHost()
	local request_ips = webip
	if string.len(_slaveHost) ~= 0 then
		request_ips = _slaveHost..'#'..webip
	end
	
	local ips = GeneralFun.stringSplit(request_ips,"#")
	
	--1.洢drbdδʾ1
	local error_tip1 = ''
	local b_ok = false
	for i=1,#ips do
		local tmpIp = ips[i]
		local role = GeneralFun.oa_detection_getRole(tmpIp)
		if role == 0 or role == 1 then
			local value = GeneralFun.getInfo(0,'{"Request":1601,"IPs":"'..tmpIp..'"}')	if value == false then return end
			local status = value[tmpIp]["status"]
			if status ~= "true" then
				if string.len(error_tip1) ~= 0 then error_tip1 = error_tip1 .. '' end
				error_tip1 = error_tip1 .. tmpIp
			end
		end
	end
	if string.len(error_tip1) ~= 0 then
		lua_addResult(p,3)
		lua_addScore(p,-100)
		lua_addTypeTip(p,3,"IP" .. error_tip1 .. '洢drbdδȷǷ״β״β볢½ϵͳãûݻ״ΣϵԶ̼֧')
		b_ok = false
		lua_afterDetect(p)
		GeneralFun.StopDetect(2,tip)
		return
	else
		lua_addResult(p,1)
		b_ok = true
	end
	
	--[[
	--2drbdǷdiskless״̬-20
	local error_tip = ''
	local b_ok = false
	for i=1,#ips do
		local tmpIp = ips[i]
		local role = GeneralFun.oa_detection_getRole(tmpIp)
		if role == 0 or role == 1 then
			local value = GeneralFun.getInfo(0,'{"Request":1602,"IPs":"'..tmpIp..'"}')	if value == false then return end
			local status = value[tmpIp]["status"]
			if status ~= "true" then
				if string.len(error_tip) ~= 0 then error_tip = error_tip .. '' end
				error_tip = error_tip .. "IP" .. tmpIp .. "״̬쳣diskless"
			end
		end
	end
	if string.len(error_tip) ~= 0 then
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTypeTip(p,3,"" .. error_tip .. 'xxӲ״̬Ƿ')
		b_ok = false
	else
		lua_addResult(p,1)
		b_ok = true
	end
	]]
	
	--3洢nfsǷ( /opt/user_disk/disk_0/.drbd),ûУ10֣ʾ3
	local error_tip3 = ''
	local value = GeneralFun.getInfo(0,'{"Request":1603,"IPs":"'..request_ips..'"}')	if value == false then return end
	for i=1,#ips do
		local tmpIp = ips[i]
		local status = value[tmpIp]["status"]
		if status ~= "true" then
			if string.len(error_tip3) ~= 0 then error_tip3 = error_tip3 .. '' end
			error_tip3 = error_tip3 .. tmpIp
		end
	end
	
	if string.len(error_tip3) ~= 0 then
		lua_addResult(p,3)
		lua_addScore(p,-100)
		lua_addTypeTip(p,3,"IP" .. error_tip3 .. "洢쳣nfsδȴ1-3ӺԣϵԶ̼֧")
		lua_afterDetect(p)
		GeneralFun.StopDetect(2,tip)
		return
	else
		lua_addResult(p,1)
	end
	
	--4.洢nfsжǷɶ
	local error_tip4 = ''
	local value = GeneralFun.getInfo(0,'{"Request":1604,"IPs":"'..request_ips..'"}')	if value == false then return end
	for i=1,#ips do
		local tmpIp = ips[i]
		local status = value[tmpIp]["status"]
		if status ~= "true" then
			if string.len(error_tip4) ~= 0 then error_tip4 = error_tip4 .. '' end
			error_tip4 = error_tip4 .. tmpIp
		end
	end
	
	if string.len(error_tip4) ~= 0 then
		lua_addResult(p,3)
		lua_addScore(p,-10)
		lua_addTypeTip(p,3,"IP" .. error_tip4 .. "nfs洢δȴ1~3ӺԣδܽϵԶ̼֧֣-10")
	else
		lua_addResult(p,1)
	end
	
	--5洢nfsǷdfǣ50֣ʾ棬ʾ5
	local error_tip5 = ''
	local value = GeneralFun.getInfo(0,'{"Request":1605,"IPs":"'..request_ips..'"}')	if value == false then return end
	for i=1,#ips do
		local tmpIp = ips[i]
		local status = value[tmpIp]["status"]
		if status ~= "true" then
			if string.len(error_tip5) ~= 0 then error_tip5 = error_tip5 .. '' end
			error_tip5 = error_tip5 .. tmpIp
		end
	end
	
	if string.len(error_tip5) ~= 0 then
		lua_addResult(p,3)
		lua_addScore(p,-50)
		lua_addTypeTip(p,3,"IP" .. error_tip5 .. "nfs洢ǿδܽϵԶ̼֧֣-50")
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection