
local detection = {}
 
local desc = 'ʱ'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = GeneralFun.getwebip()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFile("== "..desc.." ==")
		
	-- ȡӻIP	
	local value = GeneralFun.getInfo(0,'{"Request":24,"IPs":"'..webip..'"}')		if value == false then return end
	local slaveHost = value[webip]["slaveHost"]
	local needIP = ''
	for i=1,#slaveHost do
		local tmpIP = slaveHost[i]["ip"]		
		local bConnect = lua_getConnectState(tmpIP)
		if bConnect then
			if string.len(needIP) ~= 0 then needIP = needIP .. "#" end
			needIP = needIP .. tmpIP
		end
	end	
	_slaveHost = needIP
	GeneralFun.writeFile("slaveHost:<".._slaveHost..">")
	local request_ips = webip
	if string.len(_slaveHost) ~= 0 then
		request_ips = _slaveHost..'#'..webip
	end
	local ips = GeneralFun.stringSplit(request_ips,"#")
	
	-- 1ϵͳʱ뱾ϵͳʱС5ӣһ¸澯ʾ1
	local value = GeneralFun.getInfo(0,'{"Request":14,"IPs":"'..webip..'"}')	if value == false then return end
	local serverTime = value[webip]["time"]
	local localTime = os.date("%Y-%m-%d %H:%M:%S")
	local math = require "math"
	local span = math.abs(GeneralFun.stringToTime(serverTime)-GeneralFun.stringToTime(localTime))
	if span > 5*60 then
		lua_addResult(p,2)
		lua_addTypeTip(p,2,"ϵͳʱ豸ʱ䲻һ£ȷõϵͳʱǷȷ")
	else
		lua_addResult(p,1)
	end
	
	-- 2ϵͳʱǷһ£һ¿3֣ʾ2
	local value = GeneralFun.getInfo(0,'{"Request":14,"IPs":"'..request_ips..'"}')	if value == false then return false end
	local main_serverTime = value[webip]["time"]	
	local bSame = true
	local error_ip = ''	
	for i=1,#ips do
		local ip = ips[i]
		local serverTime = value[ip]["time"]
		local span = math.abs(GeneralFun.stringToTime(serverTime)-GeneralFun.stringToTime(main_serverTime))
		if span > 1*60 then
			bSame = false
			if string.len(error_ip) ~= 0 then
				error_ip = error_ip .. ""
			end
			error_ip = error_ip .. ip		 
		end
	end		
	if bSame then
		lua_addResult(p,1)
	else
		lua_addResult(p,3)
		lua_addScore(p,-3)
		lua_addTypeTip(p,3,""..error_ip.."ϵͳʱ䲻һ£ȷϵͳʱǷȷ-3")
	end
	
	-- 3ʱǷȫһ£һ£-5֣ʾ3.1or3.2	
	local value = GeneralFun.getInfo(0,'{"Request":32,"IPs":"'..request_ips..'"}')	if value == false then return false end
	local main_rebootTime = ''
	local main_reboot = value[webip]["rebootSchedule"]
	if main_reboot == 'yes' then
		main_rebootTime = value[webip]["time"]	
	end
	local bSame = true
	local error_rebootSchedule_ip = ''	
	local error_rebootTime_ip = ''	
	for i=1,#ips do
		local ip = ips[i]
		local rebootSchedule = value[ip]["rebootSchedule"]
		if rebootSchedule == "yes" then
			if main_reboot == "yes" then
				rebootTime = value[ip]["time"]	
				if rebootTime ~= main_rebootTime then
					if string.len(error_rebootTime_ip) ~= 0 then
						error_rebootTime_ip = error_rebootTime_ip .. ""
					end
					error_rebootTime_ip = error_rebootTime_ip .. ip
				end
			end			
		else			 
			if string.len(error_rebootSchedule_ip) ~= 0 then
				error_rebootSchedule_ip = error_rebootSchedule_ip .. ""
			end
			error_rebootSchedule_ip = error_rebootSchedule_ip .. ip
		end
	end		
	if string.len(error_rebootSchedule_ip) > 0 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,"в𳡾öʱ"..error_rebootSchedule_ip.."δã-5")
	elseif string.len(error_rebootTime_ip) > 0 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,""..error_rebootTime_ip.."õĶʱزһ£Ⱥ¶ʱΪͬ-5")
	else
		lua_addResult(p,1)
	end
		
	lua_afterDetect(p)
end
 
return detection