local detection = {}

local desc = 'ʦ'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

--1⹤Ƿڽʦ
function detection21_isTeacherTM()
	local webip = GeneralFun.getwebip()
	local p = GeneralFun.getClassPointer()
	
	local value = GeneralFun.getInfo(3007)	if value == false then return false end
	local netinfo = value["netinfo"]	
	local value = GeneralFun.getInfo(0,'{"Request":39,"IPs":"'..webip..'"}')	if value == false then return false end
	local classroomInfo = value[webip]
	for i=1,#netinfo do
		local localip = netinfo[i]["ip"]		
		for j=1,#classroomInfo do
			local teaIp = classroomInfo[j]["teaIp"]
			if teaIp == localip and string.len(teaIp) > 0 then
				return true
			end
		end
	end
	
	return false	
end

function detection.Detect()
	local webip = GeneralFun.getwebip()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFile("== "..desc.." ==")
	
	--1⹤Ƿڽʦϣȡýҵteacherip豸IPǷһ£
	if not detection21_isTeacherTM() then	
		lua_addResult(p,2)
		lua_addTypeTip(p,2,"ǰ豸ǽʦ޷ؼ")
		lua_afterDetect(p)
		return
	else
		lua_addResult(p,1)	
	end
		
	--2Աadmin-toolǷ뵱ǰRCD汾һ£һ¿5
	local value = GeneralFun.getInfo(0,'{"Request":30,"IPs":"'..webip..'"}')	if value == false then return end
	local ser_at_ver = value[webip]["version"]
	local value = GeneralFun.getInfo(3008)	if value == false then return end
	local at_ver = value["version"]
	if lua_compareVer(ser_at_ver,at_ver) ~= 1 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,"Աߣ-5")
	else
		lua_addResult(p,1)
	end
	
	--ǷΪۺ棬Ϊۺݲ
	local role = lua_GetProfile("USER-MSG","role")
	GeneralFun.writeFile("role== "..role)
	if role == "sale-role" then
		lua_afterDetect(p)
		return
	end
	
	--Ƿ
	local value = GeneralFun.getInfo(3018)		if value == false then return end
	local networksize = #value["result"]
	if networksize > 1 then --1
		lua_addResult(p,2)
		lua_addTypeTip(p,2,"ǰʦڶ")
	else
		lua_addResult(p,1)
	end
	
	--ǷǽCMRǷǽ
	local value = GeneralFun.getInfo(3019)		if value == false then return end
	if value["result"]["firewallState"] == "0" then --ǽر
		lua_addResult(p,1)
	else
		lua_addResult(p,2)
		lua_addTypeTip(p,2,"ʦϵͳǽܣҪƿýѧClassMannagerǽرϵͳǽӰƿýѧʹ")
	end
	
	--Ƿװɱ
	local tabBlackList={} -- 
	tabBlackList[1]={}
	tabBlackList[1]["exename"]="360tray.exe"
	tabBlackList[1]["displayname"]="360ȫʿ"
	
	tabBlackList[2]={}
	tabBlackList[2]["exename"]="BaiduSdTray.exe"
	tabBlackList[2]["displayname"]="ٶɱ"
	
	tabBlackList[3]={}
	tabBlackList[3]["exename"]="msseces.exe"
	tabBlackList[3]["displayname"]="MSE"
	
	tabBlackList[4]={}
	tabBlackList[4]["exename"]="kxetray.exe"
	tabBlackList[4]["displayname"]="ɽ"
	
	tabBlackList[5]={}
	tabBlackList[5]["exename"]="avp.exe"
	tabBlackList[5]["displayname"]="˹"
	
	tabBlackList[6]={}
	tabBlackList[6]["exename"]="avguard.exe"
	tabBlackList[6]["displayname"]="Сɡ"
	
	tabBlackList[7]={}
	tabBlackList[7]["exename"]="ekrn.exe"
	tabBlackList[7]["displayname"]="ESET NOD32"
	
	tabBlackList[8]={}
	tabBlackList[8]["exename"]="QQPCTray.exe"
	tabBlackList[8]["displayname"]="QQԹܼ"
	
	tabBlackList[9]={}
	tabBlackList[9]["exename"]="360sd.exe"
	tabBlackList[9]["displayname"]="360ɱ"
	
	tabBlackList[10]={}
	tabBlackList[10]["exename"]="360rp.exe"
	tabBlackList[10]["displayname"]="360ɱʵʱ"
	
	tabBlackList[11]={}
	tabBlackList[11]["exename"]="360Safe.exe"
	tabBlackList[11]["displayname"]="360ȫģ"
	
	local runningTab={}
	local value = GeneralFun.getInfo(3004)	if value == false then return end
	local var = value["runingPrograms"]
	local runingProgramsTab = GeneralFun.stringSplit(var,",")
	local k=0
	for i=1,#runingProgramsTab do
		local program = runingProgramsTab[i]
		for j=1,#tabBlackList do
			repeat
				local blacklistExename = tabBlackList[j]["exename"]
				if string.find(string.lower(program),string.lower(blacklistExename)) ~= nil then
					k=k+1
					runningTab[k] = {}
					runningTab[k]["DisPlayName"]=tabBlackList[j]["displayname"]
					runningTab[k]["DisPlayIcon"]=program
				else
					break
				end
			until true
		end
	end
	
	if #runningTab ~= 0 then
		lua_addResult(p,2)
		lua_addTypeTip(p,2,"⵽ʦװɱҪƿýѧClassManagerɱԷʹ쳣")
		local i=1
		while runningTab[i] do
			local DisPlayName = runningTab[i]["DisPlayName"]
			GeneralFun.writeFile("DisPlayName== "..DisPlayName.." ==")
			if string.find(DisPlayName,"360") ~= nil then --360ɱرClassManagerʦ˵ĿĿ
				lua_SetClassManagerAutoStart(false)
				break
			end
			i = i+1
		end
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection