local detection = {}

local desc = 'б'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')
	
-- δ֪ҲJЧ
function detection_isBoxVerValid(config,box_ver,box_type,rcd_osver)
	box_type = string.lower(box_type)
	local boxVersion = config["boxVersion"][box_type]
	if boxVersion == nil then return true end
	
	local boxVerId = 0
	local rcdOsVerId = 0
	for i=1,#boxVersion do
		local c_boxVer = boxVersion[i]["ver"]
		local c_osMinVer = boxVersion[i]["osver_min"]
		local c_osManVer = boxVersion[i]["osver_max"]	
		if box_ver == c_boxVer then
			boxVerId = i
		end		
		local r_min = lua_compareVer(rcd_osver,c_osMinVer)
		local r_max = lua_compareVer(rcd_osver,c_osManVer)		
		if r_min ~= 3 and r_max ~= 2 then
			rcdOsVerId = i
		end		
	end
	if rcdOsVerId == 0 or boxVerId == 0 then
		if box_type == "windows" and boxVerId == 0 then
			local box_minVer = lua_compareVer(box_ver,"1.0.8")
			if box_minVer == 3 or box_minVer == 4 then
				return false
			else
				return true
			end
		end
		return true
	end
	return boxVerId == rcdOsVerId
end
 
function detection.Detect()
	local webip = GeneralFun.getwebip()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFile("== "..desc.." ==")
	
	local value = GeneralFun.getInfo(0,'{"Request":3,"IPs":"'..webip..'"}')	if value == false then return end
	local localMode = value[webip]["localMode"]
		
	local value = GeneralFun.getInfo(0,'{"Request":6,"IPs":"'..webip..'"}')	if value == false then return end
	local rcd_dns = value[webip]["dns"]
		
	local value = GeneralFun.getInfo(0,'{"Request":5,"IPs":"'..webip..'"}')	if value == false then return end
	local ip1 = value[webip]["ip"] -- һڵַ
	local ip2 = value[webip]["ip2"] -- ڶڵַ
	
	local value = GeneralFun.getInfo(0,'{"Request":4,"IPs":"'..webip..'"}')		if value == false then return end
	local wanIp = value[webip]["ip"] -- ַ
	
	local value = GeneralFun.getInfo(0,'{"Request":8,"IPs":"'..webip..'"}')	if value == false then return end
	local webgateway = value[webip]["gateway"]
	
	local value = GeneralFun.getInfo(0,'{"Request":2,"IPs":"'..webip..'"}')	if value == false then return end
	local rcd_osver = value[webip]["version"]
	local config = GeneralFun.getConfig()
	
	local value = GeneralFun.getInfo(0,'{"Request":13,"IPs":"'..webip..'"}')	if value == false then return end
	local size = #value[webip]
	if size == 0 then
		lua_addResult(p,2)
		lua_addTypeTip(p,2,"δ½棬")
		lua_afterDetect(p)
		return
	end
	local bSamePort = true
	local bSamePort0 = true
	local bSameSubnet = true
	local bRelation = false
	local bvmDHCP = false
	local btmDHCP = false
	local bAnyOneEmpty = false
	local bNotSameDns = false
	local bAddressConflict = false
	local addressConflict = ""
	local address = ip1 .. "" .. ip2 .. ""
	if string.len(wanIp) ~= 0 then
		address = address .. wanIp .. ""
	end
	GeneralFun.writeFile("address == "..address)
	local bRedundancy = false
	local bNeedUpdate = false
	local needUpdateCount = 0
	local bHostNameConflict_vm = false
	local bHostNameConflict_tm = false
	local bHostNameConflict_all = false
	local hostNameConflict_all = ''
	local hostNameConflict_vm = ''
	local hostNameConflict_tm = ''
	local hostName_vm = ''
	local hostName_tm = ''
	local hostName_all = ''
	local hostNameConflict_tab = {}
	local vmhostNametab = {}
	local tmhostNametab = {}
	local k=1
	local vm_count = 1
	local tm_count = 1
	for i=1,size do
		if string.len(value[webip][i]["tmIp"]) ~= 0 then
			-- 10ն˽ģʽ£13ÿ̨ն˵رһڵַһ̨òȷ10֣ʾ10
			-- ն˽ģʽ£ն˵ΪһIPַ
			-- ޸ģ0ģʽҲҪȽ
			local tmGateway = value[webip][i]["tmGateway"]
			if tmGateway ~= "" then  --Ϊղжϣûͳһ
				if bSamePort and (localMode == "1" or localMode == "3") then
				if ip1 ~= tmGateway then
					GeneralFun.writeFile("tmGateway=="..tmGateway.."tmIp==" ..value[webip][i]["tmIp"])
					bSamePort = false
				end
				elseif bSamePort0 and localMode == "0" then
					if webgateway ~= tmGateway then
						bSamePort0 = false
					end
				end
			end
			-- 9ģʽ0(ն˺У԰ģʽ)ն˺ǷͬΣͬΣ10ֹ֣ͣcm-box⣬ʾ
			--	նڲͬΣȷ粿滮
			if bSameSubnet and localMode == "0" then
				--not lua_isSameSubnet(box_tearcherIP,p1,box_mask,netmask) then
				local tmIp = value[webip][i]["tmIp"]
				local tmMask = value[webip][i]["tmMask"]
				local vmIp = value[webip][i]["vmIp"]
				local vmMask = value[webip][i]["vmMask"]
				if string.len(tmIp) > 0 and string.len(tmMask) > 0 and string.len(vmIp) > 0 and string.len(vmMask) > 0 then
					if not lua_isSameSubnet(tmIp,vmIp,tmMask,vmMask) then
						bSameSubnet = false
					end
				end				
			end
		
			bRelation = true
			--1δIPƼʹþ̬IPȡģʽ  - 10
			local vmIp = value[webip][i]["vmIp"]
			if string.len(vmIp) == 0 then
				bvmDHCP = true
			end
			--2блȡնϢУģʽΪջ߶̬ģʽ-10
			local tmNetType = string.lower(value[webip][i]["tmNetType"])
			if --[[string.len(tmNetType) == 0 or]] tmNetType == "dhcp" then
				btmDHCP = true
			end
			--3.блȡնϢУ롢ءDNS Ϊգ-10
			local tmMask = value[webip][i]["tmMask"]
			local tmGateway = value[webip][i]["tmGateway"]
			local tmDns = value[webip][i]["tmDns"]
			if string.len(tmMask) == 0 or string.len(tmGateway) == 0 or string.len(tmDns) == 0 then
				bAnyOneEmpty = true
			end
			--4блȡնϢУնDNSһ£ - 5
			local tmDns = value[webip][i]["tmDns"]
			if string.len(tmDns) ~= 0 and tmDns ~= rcd_dns then
				bNotSameDns = true
			end
			--5桢նˡRCDֵַ֮ͻ-10
			local vmIp = value[webip][i]["vmIp"]
			local tmIp = value[webip][i]["tmIp"]
			if string.len(vmIp) ~= 0 then
				if string.find(address,vmIp.."") == nil then
					address = address .. vmIp .. ""
				else
					bAddressConflict = true
					if string.len(addressConflict) ~= 0 then
						addressConflict = addressConflict .. ""
					end
					addressConflict = addressConflict .. vmIp
				end
			end
			if string.len(tmIp) ~= 0 then
				if string.find(address,tmIp.."") == nil then
					address = address .. tmIp .. ""
				else
					bAddressConflict = true
					if string.len(addressConflict) ~= 0 then
						addressConflict = addressConflict .. ""
					end
					addressConflict = addressConflict .. tmIp
				end
			end
			
			--7⵽նϵͳ汾VERϰ汾 - 10		
			local box_ver = value[webip][i]["tmOsVersion"]
			local box_type = string.lower(value[webip][i]["tmOsType"])
			local ProductModel = string.lower(value[webip][i]["tmProductModel"])
			if ProductModel == "rain100 v2" then
				box_type = "linux64"
			end
			if not detection_isBoxVerValid(config,box_ver,box_type,rcd_osver) then
				bNeedUpdate = true
				needUpdateCount = needUpdateCount + 1
			end
			
			-- 8նͻ				
			local vmHostName = value[webip][i]["vmHostName"]
			local tmHostName = value[webip][i]["tmHostName"]
			if string.len(vmHostName) ~= 0 then
				if #vmhostNametab > 0 then 
					local b_exist = GeneralFun.FindSameItem(vmhostNametab,vmHostName) --ͻ
					if b_exist == true then
						bHostNameConflict_vm = true
						if string.len(hostNameConflict_vm) ~= 0 then hostNameConflict_vm = hostNameConflict_vm .. ""	 end
						hostNameConflict_vm = hostNameConflict_vm .. vmHostName
					end
				end
				vmhostNametab[vm_count] = vmHostName
				vm_count = vm_count + 1
			end
			
			if string.len(tmHostName) ~= 0 and string.lower(value[webip][i]["tmOsType"]) == "windows" then
				if #tmhostNametab > 0 then
					local b_exist = GeneralFun.FindSameItem(tmhostNametab,tmHostName) --ͻ
					if b_exist == true then
						bHostNameConflict_tm = true
						if string.len(hostNameConflict_tm) ~= 0 then hostNameConflict_tm = hostNameConflict_tm .. ""	 end
					end
				end
				tmhostNametab[tm_count] = tmHostName
				tm_count = tm_count + 1
			end
			
			if #vmhostNametab > 0 and #tmhostNametab > 0 then  --ͻ
				local confilcstr = GeneralFun.FindTabSameItem(vmhostNametab,tmhostNametab)
				if string.len(confilcstr) ~= 0 then
					bHostNameConflict_all = true
					hostNameConflict_all = confilcstr
				end
			end
			
		-- 6⵽ж棨ն˹ - 5
		else	
			bRedundancy = true			
		end
	end
	
	if not bRelation then		
		lua_addResult(p,2)
		lua_addTypeTip(p,2,"ƿδκնˣȷƿò")
		lua_afterDetect(p)
		return
	end
	
	-- 1	bvmDHCP
	if bvmDHCP then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,"Ƽʹþ̬IPģʽԷֵַֹͻ-5")
	else
		lua_addResult(p,1)
	end
	--[[
	-- 2	btmDHCP
	if btmDHCP then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,"նƼʹþ̬IPģʽʹclassmannagerѧײܶն˽һ𣬷-5")
	else
		lua_addResult(p,1)
	end
	]]
	-- 3	bAnyOneEmpty
	if bAnyOneEmpty then
		lua_addResult(p,3)
		lua_addScore(p,-3)
		lua_addTypeTip(p,3,"նòʹclassmannagerѧײܶն˽һ𣬷-3")
	else
		lua_addResult(p,1)
	end
	-- 4	bNotSameDns
	if bNotSameDns then
		lua_addResult(p,3)
		lua_addScore(p,-3)
		lua_addTypeTip(p,3,"նDNSRCDһ£ȷնDNSǷȷ-3")
	else
		lua_addResult(p,1)
	end
	-- 5	bAddressConflict
	if bAddressConflict then
		local tmpTip = "桢նˡRCDֵַ֮ͻַ滮"
		local conflict = ''
		if string.len(addressConflict)~=0 then
			conflict = conflict .. "; ͻIPУ" .. addressConflict
		end	
		lua_addResult(p,3)
		lua_addScore(p,-10)
		lua_addTypeTip(p,3,tmpTip.."(챨)",tmpTip.. conflict .. "-10")
	else
		lua_addResult(p,1)
	end
	-- 6	bRedundancy
	if bRedundancy then
		lua_addResult(p,3)
		lua_addScore(p,-2)
		lua_addRepair(p,GeneralFun.getInfoDesc(502),"502")
		lua_addTypeTip(p,3,"ó࣬ɾ棬-2")
	else
		lua_addResult(p,1)
	end
	-- 7	bNeedUpdate	needUpdateCount
	if bNeedUpdate then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,""..needUpdateCount.."̨նҪϵͳ汾-5")
	else
		lua_addResult(p,1)
	end	
	-- 8նͻ	
	if	bHostNameConflict_tm or bHostNameConflict_vm or bHostNameConflict_all then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		if bHostNameConflict_all then
			local tmp_tip = "ն֮ͻն֮"			
			lua_addTypeTip(p,3,tmp_tip.."(챨)",tmp_tip.."ͻУ"..hostNameConflict_all .. "-5")		
		end
		
		if bHostNameConflict_tm then
			local tmp_tip = "ն֮ͻն"
			lua_addTypeTip(p,3,tmp_tip.."(챨)",tmp_tip.."ͻУ"..hostNameConflict_tm .. "-5")	
		end
		
		if bHostNameConflict_vm then
			local tmp_tip = "֮ͻ"				
			lua_addTypeTip(p,3,tmp_tip.."(챨)",tmp_tip.."ͻУ"..hostNameConflict_vm .. "-5")	
		end		
		
	else
		lua_addResult(p,1)	
	end
	
	-- 10	-- ն˽ģʽ£ն˵ΪһIPַ
	if not bSamePort then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,"ն˽ģʽ£ն˵ΪһIPַ" .. "-5")
	else
		lua_addResult(p,1)
	end
	if not bSamePort0 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,"ģʽ£ն˵һ" .. "-5")
	else
		lua_addResult(p,1)
	end
	
	-- 9 bSameSubnet			--	նڲͬΣȷ粿滮
	if not bSameSubnet then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTypeTip(p,3,"նڲͬΣȷ粿滮" .. "-5")
		lua_removeDetection(p,11)
	else
		lua_addResult(p,1)
	end
	
	
	lua_afterDetect(p)
end
 
return detection
