#!/bin/bash
S_NAME=tomcat6
DB_NAME=rcd
C_DIR=$(cd "$(dirname "$0")"; pwd)
RCD_BIN=/usr/rcd/bin
DB_PORT_L=5432
DB_PORT_C=5433

cd $C_DIR

#include files
. ./common.json

tmpf=/tmp/_sqlout.tmp
def_dns=114.114.114.114


mode=`$RCD_BIN/fetchServerState.sh|grep -i message|awk -F'=' '{print $2}'|awk '{print $1}'`
role=`$RCD_BIN/fetchServerRole.sh|grep -i message|awk -F'=' '{print $2}'|awk '{print $1}'`
if [ "$mode" = "Cluster" -a "$role" = "0" ]; then
   port=$DB_PORT_C
else
   port=$DB_PORT_L
fi

tg_dns=$1

if [ -z "$tg_dns" ]; then
  tg_dns=$def_dns
fi

echo "nameserver $tg_dns" > /etc/resolv.conf

str_sql="update lb_seat_info set vm_dns1='${tg_dns}' ;"

su - postgres<<EOF
    psql -d rcd -p $port -c "${str_sql}" > $tmpf
EOF

e_json dnsRepair "ok"





